<?php

namespace App\Helpers;

class ResponseHelpers
{
    /**
     * @param $data
     * @param int $code
     * @param bool $cors
     * @return \Illuminate\Contracts\Routing\ResponseFactory|\Illuminate\Http\Response
     */
    public static function jsonResponse($data, $code = 200, $cors=false)
    {
        $host = str_replace(['http://', 'https://', '/'], '', request()->headers->get('Origin'));
        $headers = [
            'Content-type' => 'application/json'
        ];
        if($cors && in_array($host, config('app.domains'))){
            $headers['Access-Control-Allow-Origin'] = request()->headers->get('Origin');
            $headers['Access-Control-Allow-Credentials'] = 'true';
        }
        return response(
            json_encode(
                $data,
                JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES
            ),
            $code,
            $headers
        );
    }
}
